﻿using UnityEngine;
using UnityEngine.Events;

namespace CarMod
{
    public class CarMod
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Audi A4",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Cars/Audi A4/Thumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        var body = Instance.transform.GetChild(0);
                        body.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Audi A4/BodyCollisionMask.png", 3f);
                        body.gameObject.FixColliders();
                        body.GetComponent<CarBehaviour>().MotorSpeed = -4850f;
                        body.gameObject.GetOrAddComponent<HeadlightBehaviour>().GlowSprite = ModAPI.LoadSprite("Cars/Audi A4/Glow.png");
                        body.GetChild(0).localPosition = new Vector2(0f, 0f);

                        var boot = Instance.transform.GetChild(4);
                        boot.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Audi A4/BootCollisionMask.png", 5f);
                        boot.gameObject.FixColliders();
                        boot.GetComponent<HingeJoint2D>().anchor = new Vector2(0.41f, 0.2f);
                        boot.localPosition = new Vector2(-3.04f, 0.13f);

                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Audi A4/BonnetCollisionMask.png", 5f);
                        bonnet.gameObject.FixColliders();
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.8f, 0.09f);
                        bonnet.localPosition = new Vector2(2.45f, 0.08f);

                        var frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Audi A4/FrontDoorCollisionMask.png", 5f);
                        frontDoor.gameObject.FixColliders();
                        frontDoor.localPosition = new Vector2(0.5f, 0.01f);

                        var backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Audi A4/BackDoorCollisionMask.png", 5f);
                        backDoor.gameObject.FixColliders();
                        backDoor.localPosition = new Vector2(-1.05f, 0.01f);

                        Instance.transform.GetChild(8).localPosition = new Vector2(-2.3f, -0.3f);
                        Instance.transform.GetChild(7).localPosition = new Vector2(2.2f, -0.25f);

                        WheelJoint2D[] wheel = body.GetComponents<WheelJoint2D>();
                        wheel[0].anchor = new Vector2(2.35f, -0.8f);
                        wheel[1].anchor = new Vector2(-2.09f, -0.8f);

                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Cars/Audi A4/BlackColor/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Cars/Audi A4/BlackColor/Background.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Cars/Audi A4/BlackColor/Bonnet.png");
                        CarSprite1.Boot = ModAPI.LoadSprite("Cars/Audi A4/BlackColor/Boot.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Cars/Audi A4/BlackColor/FrontDoor.png");
                        CarSprite1.BackDoor = ModAPI.LoadSprite("Cars/Audi A4/BlackColor/BackDoor.png");
                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Cars/Audi A4/BlueColor/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Cars/Audi A4/BlueColor/Background.png");
                        CarSprite2.Bonnet = ModAPI.LoadSprite("Cars/Audi A4/BlueColor/Bonnet.png");
                        CarSprite2.Boot = ModAPI.LoadSprite("Cars/Audi A4/BlueColor/Boot.png");
                        CarSprite2.FrontDoor = ModAPI.LoadSprite("Cars/Audi A4/BlueColor/FrontDoor.png");
                        CarSprite2.BackDoor = ModAPI.LoadSprite("Cars/Audi A4/BlueColor/BackDoor.png");
                        var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite3.Body = ModAPI.LoadSprite("Cars/Audi A4/GrayColor/Body.png");
                        CarSprite3.Background = ModAPI.LoadSprite("Cars/Audi A4/GrayColor/Background.png");
                        CarSprite3.Bonnet = ModAPI.LoadSprite("Cars/Audi A4/GrayColor/Bonnet.png");
                        CarSprite3.Boot = ModAPI.LoadSprite("Cars/Audi A4/GrayColor/Boot.png");
                        CarSprite3.FrontDoor = ModAPI.LoadSprite("Cars/Audi A4/GrayColor/FrontDoor.png");
                        CarSprite3.BackDoor = ModAPI.LoadSprite("Cars/Audi A4/GrayColor/BackDoor.png");
                        var CarSprite4 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite4.Body = ModAPI.LoadSprite("Cars/Audi A4/GreenColor/Body.png");
                        CarSprite4.Background = ModAPI.LoadSprite("Cars/Audi A4/GreenColor/Background.png");
                        CarSprite4.Bonnet = ModAPI.LoadSprite("Cars/Audi A4/GreenColor/Bonnet.png");
                        CarSprite4.Boot = ModAPI.LoadSprite("Cars/Audi A4/GreenColor/Boot.png");
                        CarSprite4.FrontDoor = ModAPI.LoadSprite("Cars/Audi A4/GreenColor/FrontDoor.png");
                        CarSprite4.BackDoor = ModAPI.LoadSprite("Cars/Audi A4/GreenColor/BackDoor.png");
                        var CarSprite5 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite5.Body = ModAPI.LoadSprite("Cars/Audi A4/RedColor/Body.png");
                        CarSprite5.Background = ModAPI.LoadSprite("Cars/Audi A4/RedColor/Background.png");
                        CarSprite5.Bonnet = ModAPI.LoadSprite("Cars/Audi A4/RedColor/Bonnet.png");
                        CarSprite5.Boot = ModAPI.LoadSprite("Cars/Audi A4/RedColor/Boot.png");
                        CarSprite5.FrontDoor = ModAPI.LoadSprite("Cars/Audi A4/RedColor/FrontDoor.png");
                        CarSprite5.BackDoor = ModAPI.LoadSprite("Cars/Audi A4/RedColor/BackDoor.png");
                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                            CarSprite3,
                            CarSprite4,
                            CarSprite5
                        };

                        var collide = Instance.AddComponent<NoCollide>();
                        collide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        collide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Lada 2104",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Cars/Lada 2104/Thumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        var body = Instance.transform.GetChild(0);
                        body.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Lada 2104/BodyCollisionMask.png", 3f);
                        body.gameObject.FixColliders();
                        body.GetComponent<CarBehaviour>().MotorSpeed = -3400f;
                        body.gameObject.GetOrAddComponent<HeadlightBehaviour>().GlowSprite = ModAPI.LoadSprite("Cars/Lada 2104/Glow.png");
                        body.GetChild(0).localPosition = new Vector2(0f, 0f);

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Lada 2104/BonnetCollisionMask.png", 5f);
                        bonnet.gameObject.FixColliders();
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.87f, 0.08f);
                        bonnet.localPosition = new Vector2(2.44f, 0.015f);

                        var frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Lada 2104/FrontDoorCollisionMask.png", 5f);
                        frontDoor.gameObject.FixColliders();
                        frontDoor.localPosition = new Vector2(0.685f, 0.015f);

                        var backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Lada 2104/BackDoorCollisionMask.png", 5f);
                        backDoor.gameObject.FixColliders();
                        backDoor.localPosition = new Vector2(-0.84f, 0.027f);

                        Instance.transform.GetChild(8).localPosition = new Vector2(-2.1f, -0.35f);
                        Instance.transform.GetChild(7).localPosition = new Vector2(2.3f, -0.35f);

                        WheelJoint2D[] wheel = body.GetComponents<WheelJoint2D>();
                        wheel[0].anchor = new Vector2(2.35f, -0.9f);
                        wheel[0].connectedBody.transform.localScale = new Vector2(0.9f, 0.9f);
                        wheel[1].anchor = new Vector2(-1.7f, -0.9f);
                        wheel[1].connectedBody.transform.localScale = new Vector2(0.9f, 0.9f);

                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Cars/Lada 2104/BlackColor/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Cars/Lada 2104/Background.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Cars/Lada 2104/BlackColor/Bonnet.png");
                        CarSprite1.Boot = ModAPI.LoadSprite("Cars/Lada 2104/BlackColor/Boot.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Cars/Lada 2104/BlackColor/FrontDoor.png");
                        CarSprite1.BackDoor = ModAPI.LoadSprite("Cars/Lada 2104/BlackColor/BackDoor.png");
                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Cars/Lada 2104/BlueColor/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Cars/Lada 2104/Background.png");
                        CarSprite2.Bonnet = ModAPI.LoadSprite("Cars/Lada 2104/BlueColor/Bonnet.png");
                        CarSprite2.Boot = ModAPI.LoadSprite("Cars/Lada 2104/BlueColor/Boot.png");
                        CarSprite2.FrontDoor = ModAPI.LoadSprite("Cars/Lada 2104/BlueColor/FrontDoor.png");
                        CarSprite2.BackDoor = ModAPI.LoadSprite("Cars/Lada 2104/BlueColor/BackDoor.png");
                        var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite3.Body = ModAPI.LoadSprite("Cars/Lada 2104/GrayColor/Body.png");
                        CarSprite3.Background = ModAPI.LoadSprite("Cars/Lada 2104/Background.png");
                        CarSprite3.Bonnet = ModAPI.LoadSprite("Cars/Lada 2104/GrayColor/Bonnet.png");
                        CarSprite3.Boot = ModAPI.LoadSprite("Cars/Lada 2104/GrayColor/Boot.png");
                        CarSprite3.FrontDoor = ModAPI.LoadSprite("Cars/Lada 2104/GrayColor/FrontDoor.png");
                        CarSprite3.BackDoor = ModAPI.LoadSprite("Cars/Lada 2104/GrayColor/BackDoor.png");
                        var CarSprite4 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite4.Body = ModAPI.LoadSprite("Cars/Lada 2104/GreenColor/Body.png");
                        CarSprite4.Background = ModAPI.LoadSprite("Cars/Lada 2104/Background.png");
                        CarSprite4.Bonnet = ModAPI.LoadSprite("Cars/Lada 2104/GreenColor/Bonnet.png");
                        CarSprite4.Boot = ModAPI.LoadSprite("Cars/Lada 2104/GreenColor/Boot.png");
                        CarSprite4.FrontDoor = ModAPI.LoadSprite("Cars/Lada 2104/GreenColor/FrontDoor.png");
                        CarSprite4.BackDoor = ModAPI.LoadSprite("Cars/Lada 2104/GreenColor/BackDoor.png");
                        var CarSprite5 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite5.Body = ModAPI.LoadSprite("Cars/Lada 2104/RedColor/Body.png");
                        CarSprite5.Background = ModAPI.LoadSprite("Cars/Lada 2104/Background.png");
                        CarSprite5.Bonnet = ModAPI.LoadSprite("Cars/Lada 2104/RedColor/Bonnet.png");
                        CarSprite5.Boot = ModAPI.LoadSprite("Cars/Lada 2104/RedColor/Boot.png");
                        CarSprite5.FrontDoor = ModAPI.LoadSprite("Cars/Lada 2104/RedColor/FrontDoor.png");
                        CarSprite5.BackDoor = ModAPI.LoadSprite("Cars/Lada 2104/RedColor/BackDoor.png");
                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                            CarSprite3,
                            CarSprite4,
                            CarSprite5
                        };

                        var collide = Instance.AddComponent<NoCollide>();
                        collide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        collide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
	    }
    }
    public class HeadlightBehaviour : MonoBehaviour
    {
        private void Start()
        {
            glow = new GameObject("Glow");
            glow.transform.parent = gameObject.transform;
            glow.transform.rotation = gameObject.transform.rotation;
            glow.transform.localPosition = new Vector3(0f, 0f);
            glow.transform.localScale = new Vector3(1f, 1f);
            glowRenderer = glow.GetOrAddComponent<SpriteRenderer>();
            glowRenderer.sprite = GlowSprite;
            glowRenderer.material = ModAPI.FindMaterial("VeryBright");
            glowRenderer.color = new Color32(0, 0, 0, 0);
            glowRenderer.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleHeadlights", delegate()
            {
                if(!OnHeadlights)
                {
                    return "Enable headlights";
                }
                return "Disable headlights";
            }, "Toggles headlights", new UnityAction[]
            {
                delegate()
                {
                    OnHeadlights = !OnHeadlights;
                }
            }));
        }
        private void FixedUpdate()
        {
            if(OnHeadlights)
            {
                glowRenderer.color = new Color32(120, 120, 120, 200);
            }
            if(!OnHeadlights)
            {
                glowRenderer.color = new Color32(0, 0, 0, 0);
            }
        }

        public bool OnHeadlights;
        private GameObject glow;
        private SpriteRenderer glowRenderer;
        public Sprite GlowSprite;
    }
}